package com.emato.cus.supervise.biz.acqShelfLoad.down;

import com.emato.cus.supervise.biz.DataConversion;
import com.emato.cus.supervise.constant.Dict;
import com.emato.cus.supervise.domain.WmsAcqShelfLoad;
import com.emato.cus.supervise.domainCus.CusAcqShelfLoad04;
import com.emato.cus.supervise.domainOms.OmsProductInfo;
import com.google.common.collect.Lists;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 *
 * @author zengjunlin
 * @version 1.0
 * 2018-02-03 13:40
 */
@Component
public class AcqShelfLoadDownDataConversion implements DataConversion {


    private final static Logger logger = LoggerFactory.getLogger(AcqShelfLoadDownDataConversion.class);

    /**
     * 企业货物上下架信息组装
     * 外部数据转换
     * @param params
     * @return
     */
    @Override
    public List conversion(Map params) {
        logger.info("开始转换oms，wms 组装cus数据===========================");
        List<WmsAcqShelfLoad> wmsList = (List<WmsAcqShelfLoad>) params.get("wmsList");
        List<CusAcqShelfLoad04> cusAcqShelfLoad04List = Lists.newArrayList();

        List<OmsProductInfo> productInfoList = (List<OmsProductInfo>) params.get("productInfoList");
        final Map<String,OmsProductInfo> omsProductInfoMap = productInfoList.stream().collect(Collectors.toMap(k->k.getSkuNo(), v->v));

        for (int i = 0; i < wmsList.size(); i++) {
            WmsAcqShelfLoad wmsAcqShelfLoad = wmsList.get(i);

            OmsProductInfo omsProductInfo = omsProductInfoMap.get(wmsAcqShelfLoad.getSkuNo());

            CusAcqShelfLoad04 cusAcqShelfLoad04 = new CusAcqShelfLoad04();
            cusAcqShelfLoad04.setId(wmsAcqShelfLoad.getId());
            cusAcqShelfLoad04.setGoodsName(wmsAcqShelfLoad.getGoodsName());

//            cusAcqShelfLoad04.setCodeTs(wmsAcqShelfLoad.getCodeTs());

            cusAcqShelfLoad04.setFormNoDec(wmsAcqShelfLoad.getFormNoDec());
            cusAcqShelfLoad04.setFormNo(wmsAcqShelfLoad.getFormNo());
            cusAcqShelfLoad04.setSkuNo(wmsAcqShelfLoad.getSkuNo());
            cusAcqShelfLoad04.setGoodsId(wmsAcqShelfLoad.getGoodsId());
            cusAcqShelfLoad04.setgUnit(wmsAcqShelfLoad.getgUnit());
            cusAcqShelfLoad04.setgQty(wmsAcqShelfLoad.getgQty());
            cusAcqShelfLoad04.setLegalUnit(wmsAcqShelfLoad.getLegalUnit());
            cusAcqShelfLoad04.setLegalQty(wmsAcqShelfLoad.getLegalQty());
            cusAcqShelfLoad04.setGoodsModel(wmsAcqShelfLoad.getGoodsModel());
            cusAcqShelfLoad04.setLocalEmsNo(Dict.localEmsNo);
            cusAcqShelfLoad04.setSeatNo(wmsAcqShelfLoad.getSeatNo());
            cusAcqShelfLoad04.setShelfLoadTime(wmsAcqShelfLoad.getShelfLoadTime());
            cusAcqShelfLoad04.setShelfLoadType(wmsAcqShelfLoad.getShelfLoadType());
            cusAcqShelfLoad04.setStoreCompanyName(Dict.storeCompanyName);
            cusAcqShelfLoad04.setStoreUscCode(Dict.storeUscCode);
            cusAcqShelfLoad04.setStoreCustomsCode(Dict.storeCustomsCode);
            cusAcqShelfLoad04.setStoreCode(Dict.storeCode);
            cusAcqShelfLoad04.setCreateTime(LocalDateTime.now());
            cusAcqShelfLoad04.setCreaterSn("1");
            cusAcqShelfLoad04.setModerSn("1");
            cusAcqShelfLoad04.setModTime(LocalDateTime.now());
            cusAcqShelfLoad04.setLegalQty(omsProductInfo.getLegalQyt());
            cusAcqShelfLoad04.setLegalUnit(omsProductInfo.getLegalUnit());
            cusAcqShelfLoad04.setGoodsModel(omsProductInfo.getGoodsModel());
            cusAcqShelfLoad04.setCodeTs(omsProductInfo.getCodeTs());
            cusAcqShelfLoad04List.add(cusAcqShelfLoad04);
        }
        logger.info("转换oms，wms 组装cus数据结束===========================");
        return cusAcqShelfLoad04List;
    }
}
